/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@ricochet.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2001-2004 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.venice.core;

import java.io.InputStream;
import java.util.Date;
import java.sql.Connection;
import com.silverwrist.venice.util.VCard;

public interface ContactInfo
{
  public abstract int getContactID();

  public abstract String getGivenName();

  public abstract void setGivenName(String name);

  public abstract String getFamilyName();

  public abstract void setFamilyName(String name);

  public abstract char getMiddleInitial();

  public abstract void setMiddleInitial(char in);

  public abstract String getNamePrefix();

  public abstract void setNamePrefix(String p);

  public abstract String getNameSuffix();

  public abstract void setNameSuffix(String s);

  public abstract String getCompany();

  public abstract void setCompany(String c);

  public abstract String getAddressLine1();

  public abstract void setAddressLine1(String addr);

  public abstract String getAddressLine2();

  public abstract void setAddressLine2(String addr);

  public abstract String getLocality();

  public abstract void setLocality(String city);

  public abstract String getRegion();

  public abstract void setRegion(String state);

  public abstract String getPostalCode();

  public abstract void setPostalCode(String zip);

  public abstract String getCountry();

  public abstract void setCountry(String c);

  public abstract String getPhone();

  public abstract void setPhone(String num);

  public abstract String getFax();

  public abstract void setFax(String num);

  public abstract String getMobile();

  public abstract void setMobile(String num);

  public abstract String getEmail();

  public abstract void setEmail(String addr);

  public abstract String getPhotoURL();

  public abstract void setPhotoURL(String addr);

  public abstract void setPhotoData(String prefix, String mimetype, int length, InputStream data);

  public abstract String getURL();

  public abstract void setURL(String addr);

  public abstract boolean getPrivateAddress();

  public abstract void setPrivateAddress(boolean flag);

  public abstract boolean getPrivatePhone();

  public abstract void setPrivatePhone(boolean flag);

  public abstract boolean getPrivateFax();

  public abstract void setPrivateFax(boolean flag);

  public abstract boolean getPrivateEmail();

  public abstract void setPrivateEmail(boolean flag);

  public abstract int getOwnerUID();

  public abstract int getOwnerCommunityID();

  public abstract Date getLastUpdate();

  public abstract boolean getModified();

  public abstract void importVCard(VCard vc);

  public abstract VCard exportVCard();

  public abstract boolean canSetPhoto();

} // end interface ContactInfo
